// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * OpenFMB specialization for control schedule using:  LN: Schedule   Name: FSCH
 * </pre>
 *
 * Protobuf type {@code commonmodule.ControlScheduleFSCH}
 */
public final class ControlScheduleFSCH extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ControlScheduleFSCH)
    ControlScheduleFSCHOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ControlScheduleFSCH.newBuilder() to construct.
  private ControlScheduleFSCH(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ControlScheduleFSCH() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ControlScheduleFSCH();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ControlScheduleFSCH_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ControlScheduleFSCH_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ControlScheduleFSCH.class, openfmb.commonmodule.ControlScheduleFSCH.Builder.class);
  }

  public static final int VALACSG_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ScheduleCSG valACSG_;
  /**
   * <pre>
   * Analog CSG
   * </pre>
   *
   * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the valACSG field is set.
   */
  @java.lang.Override
  public boolean hasValACSG() {
    return valACSG_ != null;
  }
  /**
   * <pre>
   * Analog CSG
   * </pre>
   *
   * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The valACSG.
   */
  @java.lang.Override
  public openfmb.commonmodule.ScheduleCSG getValACSG() {
    return valACSG_ == null ? openfmb.commonmodule.ScheduleCSG.getDefaultInstance() : valACSG_;
  }
  /**
   * <pre>
   * Analog CSG
   * </pre>
   *
   * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ScheduleCSGOrBuilder getValACSGOrBuilder() {
    return valACSG_ == null ? openfmb.commonmodule.ScheduleCSG.getDefaultInstance() : valACSG_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (valACSG_ != null) {
      output.writeMessage(1, getValACSG());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (valACSG_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getValACSG());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ControlScheduleFSCH)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ControlScheduleFSCH other = (openfmb.commonmodule.ControlScheduleFSCH) obj;

    if (hasValACSG() != other.hasValACSG()) return false;
    if (hasValACSG()) {
      if (!getValACSG()
          .equals(other.getValACSG())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasValACSG()) {
      hash = (37 * hash) + VALACSG_FIELD_NUMBER;
      hash = (53 * hash) + getValACSG().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ControlScheduleFSCH parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ControlScheduleFSCH prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * OpenFMB specialization for control schedule using:  LN: Schedule   Name: FSCH
   * </pre>
   *
   * Protobuf type {@code commonmodule.ControlScheduleFSCH}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ControlScheduleFSCH)
      openfmb.commonmodule.ControlScheduleFSCHOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ControlScheduleFSCH_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ControlScheduleFSCH_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ControlScheduleFSCH.class, openfmb.commonmodule.ControlScheduleFSCH.Builder.class);
    }

    // Construct using openfmb.commonmodule.ControlScheduleFSCH.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      valACSG_ = null;
      if (valACSGBuilder_ != null) {
        valACSGBuilder_.dispose();
        valACSGBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ControlScheduleFSCH_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ControlScheduleFSCH getDefaultInstanceForType() {
      return openfmb.commonmodule.ControlScheduleFSCH.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ControlScheduleFSCH build() {
      openfmb.commonmodule.ControlScheduleFSCH result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ControlScheduleFSCH buildPartial() {
      openfmb.commonmodule.ControlScheduleFSCH result = new openfmb.commonmodule.ControlScheduleFSCH(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ControlScheduleFSCH result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.valACSG_ = valACSGBuilder_ == null
            ? valACSG_
            : valACSGBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ControlScheduleFSCH) {
        return mergeFrom((openfmb.commonmodule.ControlScheduleFSCH)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ControlScheduleFSCH other) {
      if (other == openfmb.commonmodule.ControlScheduleFSCH.getDefaultInstance()) return this;
      if (other.hasValACSG()) {
        mergeValACSG(other.getValACSG());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getValACSGFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ScheduleCSG valACSG_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ScheduleCSG, openfmb.commonmodule.ScheduleCSG.Builder, openfmb.commonmodule.ScheduleCSGOrBuilder> valACSGBuilder_;
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the valACSG field is set.
     */
    public boolean hasValACSG() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The valACSG.
     */
    public openfmb.commonmodule.ScheduleCSG getValACSG() {
      if (valACSGBuilder_ == null) {
        return valACSG_ == null ? openfmb.commonmodule.ScheduleCSG.getDefaultInstance() : valACSG_;
      } else {
        return valACSGBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setValACSG(openfmb.commonmodule.ScheduleCSG value) {
      if (valACSGBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        valACSG_ = value;
      } else {
        valACSGBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setValACSG(
        openfmb.commonmodule.ScheduleCSG.Builder builderForValue) {
      if (valACSGBuilder_ == null) {
        valACSG_ = builderForValue.build();
      } else {
        valACSGBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeValACSG(openfmb.commonmodule.ScheduleCSG value) {
      if (valACSGBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          valACSG_ != null &&
          valACSG_ != openfmb.commonmodule.ScheduleCSG.getDefaultInstance()) {
          getValACSGBuilder().mergeFrom(value);
        } else {
          valACSG_ = value;
        }
      } else {
        valACSGBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearValACSG() {
      bitField0_ = (bitField0_ & ~0x00000001);
      valACSG_ = null;
      if (valACSGBuilder_ != null) {
        valACSGBuilder_.dispose();
        valACSGBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ScheduleCSG.Builder getValACSGBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getValACSGFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ScheduleCSGOrBuilder getValACSGOrBuilder() {
      if (valACSGBuilder_ != null) {
        return valACSGBuilder_.getMessageOrBuilder();
      } else {
        return valACSG_ == null ?
            openfmb.commonmodule.ScheduleCSG.getDefaultInstance() : valACSG_;
      }
    }
    /**
     * <pre>
     * Analog CSG
     * </pre>
     *
     * <code>.commonmodule.ScheduleCSG ValACSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ScheduleCSG, openfmb.commonmodule.ScheduleCSG.Builder, openfmb.commonmodule.ScheduleCSGOrBuilder> 
        getValACSGFieldBuilder() {
      if (valACSGBuilder_ == null) {
        valACSGBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ScheduleCSG, openfmb.commonmodule.ScheduleCSG.Builder, openfmb.commonmodule.ScheduleCSGOrBuilder>(
                getValACSG(),
                getParentForChildren(),
                isClean());
        valACSG_ = null;
      }
      return valACSGBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ControlScheduleFSCH)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ControlScheduleFSCH)
  private static final openfmb.commonmodule.ControlScheduleFSCH DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ControlScheduleFSCH();
  }

  public static openfmb.commonmodule.ControlScheduleFSCH getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ControlScheduleFSCH>
      PARSER = new com.google.protobuf.AbstractParser<ControlScheduleFSCH>() {
    @java.lang.Override
    public ControlScheduleFSCH parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ControlScheduleFSCH> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ControlScheduleFSCH> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ControlScheduleFSCH getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

